package com.wjh.camera;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.graphics.PixelFormat;
import android.hardware.Camera;
import android.hardware.Camera.AutoFocusCallback;
import android.hardware.Camera.PictureCallback;
import android.os.Bundle;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceHolder.Callback;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Toast;

public class MainActivity extends Activity implements Callback, OnClickListener, AutoFocusCallback{
	SurfaceView mySurfaceView;//surfaceView  
    SurfaceHolder holder;//surfaceHolder  
    Camera myCamera;//  
    String filePath="/sdcard/wuchaowen123.jpg";//Ƭ·  
    public static int takeType = 0;//0Ǻģ1ǽ
    int orientation = 0;
    boolean isClicked = false;//Ƿʶ  
    //jpegͼƬصݶ  
    PictureCallback jpeg = new PictureCallback() {  
          
        @Override  
        public void onPictureTaken(byte[] data, Camera camera) {  
            // TODO Auto-generated method stub  
        	 Bitmap bMap; 
            try  
            {// ͼƬ  
            	 
    	        
    	        bMap = BitmapFactory.decodeByteArray(data, 0, data.length);  
    	         
    	        Bitmap bMapRotate;  
    	        if (takeType != 0) {  //
    	            Matrix matrix = new Matrix();  
    	            matrix.reset();  
    	            matrix.postRotate(90);  
    	            bMapRotate = Bitmap.createBitmap(bMap, 0, 0, bMap.getWidth(),  
    	                    bMap.getHeight(), matrix, true); 
    	            bMap = bMapRotate;
    	        }
          
           // Bitmap bm = BitmapFactory.decodeByteArray(data, 0, data.length);  
            File file = new File(filePath);  
            BufferedOutputStream bos =  
                new BufferedOutputStream(new FileOutputStream(file));  
            bMap.compress(Bitmap.CompressFormat.JPEG, 100, bos);//ͼƬѹ  
            bos.flush();//  
            bos.close();//ر  
            }catch(Exception e)  
            {  
                e.printStackTrace();  
            }  
              
        }  
    };  
    @Override
    protected void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
    	requestWindowFeature(Window.FEATURE_NO_TITLE);//ޱ             
        //㷽  
       // this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);  
        setContentView(R.layout.main);  
        //ÿؼ  
        mySurfaceView = (SurfaceView)findViewById(R.id.surfaceView1);  
        //þ  
        holder = mySurfaceView.getHolder();  
        //ӻص  
        holder.addCallback(this);  
        //  
        holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);  
        //ü  
        mySurfaceView.setOnClickListener(this); 
    }

	@Override
	public void onAutoFocus(boolean success, Camera camera) {
		if(success)  
        {  
            //ò,  
            Camera.Parameters params = myCamera.getParameters();  
            params.setPictureFormat(PixelFormat.JPEG);  
            params.setPreviewSize(640,480);  
            myCamera.setParameters(params);  
            myCamera.takePicture(null, null, jpeg);  
        }  
		
	}

	@Override
	public void onClick(View v) {
		if(!isClicked)  
        {  
            myCamera.autoFocus(this);//ԶԽ  
            isClicked = true;  
        }else  
        {  
            myCamera.startPreview();//Ԥ  
            isClicked = false;  
        }  
		
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		 //òʼԤ  
		Log.d("surfaceChanged", "--------------surfaceChanged------------------");
        Camera.Parameters params = myCamera.getParameters();  
        params.setPictureFormat(PixelFormat.JPEG);  
        if (getWindowManager().getDefaultDisplay().getOrientation() == 0){//
        	Log.d("0", "setPreviewSize:"+height+"*"+width);
        	params.setPreviewSize(height, width);
        	myCamera.setDisplayOrientation(90);
        }else {  //
        	Log.d("1", "setPreviewSize:"+width+"*"+height);
        	params.setPreviewSize(width, height);
        	myCamera.setDisplayOrientation(0);
		}
        params.setPreviewSize(640,480);  
        myCamera.setParameters(params);  
        myCamera.startPreview(); 
		
	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		 //  
        if(myCamera == null)  
        {  
            myCamera = Camera.open();  
            try {  
                myCamera.setPreviewDisplay(holder);  
            } catch (IOException e) {  
                // TODO Auto-generated catch block  
                e.printStackTrace();  
            }  
        }  
		
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		 //رԤͷԴ  
        myCamera.stopPreview();  
        myCamera.release();  
        myCamera = null;  
		
	}
	

	@Override  
    public void onConfigurationChanged(Configuration newConfig) {  
   	 Log.d("onConfigurationChanged", "-------onConfigurationChanged----------");
    int type = this.getResources().getConfiguration().orientation;  
      
    if (type == Configuration.ORIENTATION_LANDSCAPE) {  
        //л˺  
    	takeType = 0;
   	   Toast.makeText(MainActivity.this, ":"+type, Toast.LENGTH_SHORT).show();
   	// myCamera.setDisplayOrientation(0);
    } else if (type == Configuration.ORIENTATION_PORTRAIT) {  
        //л  
        takeType = 1;
       // myCamera.setDisplayOrientation(90);
    	 Toast.makeText(MainActivity.this, ":"+type, Toast.LENGTH_SHORT).show();
    }  
      
    super.onConfigurationChanged(newConfig);  
    } 

	
	
}
